﻿using System;
using Microsoft.SqlServer.Management.Smo;
using System.Data;

namespace IntroToSmo
{
    public partial class Program1 : System.Web.UI.Page
    {
        /// <summary>
        /// 
        /// This program illustrates how to connect to an SQL Instance and use SMO to retreive a list of 
        /// databases from the instance
        /// 
        /// </summary>
        
        protected void Page_Load(object sender, EventArgs e)
        {
            // connect to the default instance on the named server
            Server myServer = new Server("SQL2012SERVER");                               // Change to your server name
            myServer.ConnectionContext.ConnectAsUser = true;
            myServer.ConnectionContext.ConnectAsUserName = "myusername@mydomainname";   // change to your user name@domain
            myServer.ConnectionContext.ConnectAsUserPassword = "myPassword";            // change to your password
            myServer.ConnectionContext.Connect();

            // create the datatable to be used as a data source for the GridView
            DataTable myDataTable = new DataTable();
            myDataTable.Columns.Add("DataBasename", typeof(string));

            // fill in the data table with the database names
            foreach (Database myDatabase in myServer.Databases)
            {
                myDataTable.Rows.Add(myDatabase.Name);
            }

            // bind it to the GridView ready for the web form to present it
            GridView1.DataSource = myDataTable;
            GridView1.DataBind();

        }
    }
}