﻿using System;
using Microsoft.SqlServer.Management.Smo;
using System.Data;
using System.Diagnostics;

namespace IntroToSmo
{
    public partial class Program2 : System.Web.UI.Page
    {
        /// <summary>
        /// 
        /// This program illustrates how to connect to an SQL Instance and use the diagnostics to retreive
        /// a list of the last 100 application log entries
        /// 
        /// While this is not specific to SMO, this has been included for continuity of the story in the article
        /// 
        /// </summary>
        
        protected void Page_Load(object sender, EventArgs e)
        {
            // connect to the default instance on the named server
            Server myServer = new Server("SQL2012SERVER");                               // Change to your server name
            myServer.ConnectionContext.ConnectAsUser = true;
            myServer.ConnectionContext.ConnectAsUserName = "myusername@mydomainname";   // change to your user name@domain
            myServer.ConnectionContext.ConnectAsUserPassword = "myPassword";            // change to your password
            myServer.ConnectionContext.Connect();

            // Create the instance of the the windows application log
            EventLog mySmoLog = new EventLog("Application", "SQLDEV2012");

            // create the datatable to be used as a data source for the GridView
            DataTable myLogTable = new DataTable();
            myLogTable.Columns.Add("EventIdd", typeof(long));
            myLogTable.Columns.Add("EntryType", typeof(string));
            myLogTable.Columns.Add("Message", typeof(string));

            // fill in the data table for the last 100 entries from the application log
            for (int i = mySmoLog.Entries.Count-100 ; i < mySmoLog.Entries.Count - 1; i++)
            {
                EventLogEntry CurrentEntry = mySmoLog.Entries[i];
                myLogTable.Rows.Add(CurrentEntry.InstanceId, CurrentEntry.EntryType, CurrentEntry.Message);
            }

            // bind it to the GridView ready for the web form to present it
            GridView1.DataSource = myLogTable;
            GridView1.DataBind();

        }
    }
}