﻿using System;
using Microsoft.SqlServer.Management.Smo;

namespace IntroToSmo
{
    public partial class Program5 : System.Web.UI.Page
    {
        /// <summary>
        /// 
        /// This program illustrates how to connect to an SQL Instance and use SMO to add a role 
        /// to a specific user of a named database
        /// 
        /// </summary>

        protected void Page_Load(object sender, EventArgs e)
        {
            // connect to the default instance on the named server
            Server myServer = new Server("SQL2012SERVER");                               // Change to your server name
            myServer.ConnectionContext.ConnectAsUser = true;
            myServer.ConnectionContext.ConnectAsUserName = "myusername@mydomainname";   // change to your user name@domain
            myServer.ConnectionContext.ConnectAsUserPassword = "myPassword";            // change to your password
            myServer.ConnectionContext.Connect();

            // Gets the list of users for the named database
            UserCollection myUsersList = myServer.Databases["MyInstantHelpdesk_Development"].Users;

            // get the specific user instance 
            Microsoft.SqlServer.Management.Smo.User myUser = myUsersList["myinstanthelpdesk"];
            
            // add the role to the user - note that this is the update. NO COMMIT logic needed 
            myUser.AddToRole("db_owner");                                               // Add db_Owner role to the current SMO user

            // Job done - I can go back to sleep now :)
        }
    }
}